//+------------------------------------------------------------------+
//|                                           FX Sniper's T3 MoM.mq4 |
//|                                       Original Code by FX Sniper |
//|                                  Copyright  2008, Forex-TSD.com |
//|                                              Written by Linuxser |
//|For more information read TASC January 1998                       |
//|Thanks to mladen to notify me about the error in orig algorithm   |
//|http://www.linuxser.com.ar/                                       |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_level1  0
#property  indicator_levelcolor Gray
#property  indicator_levelstyle 0
//----
extern int MoM_Period = 14;
extern int T3_Period = 5;
extern double b = 0.618;
extern bool Histogram  = false;

//----
double e1, e2, e3, e4, e5, e6;
double c1, c2, c3, c4;
double n, w1, w2, b2, b3;
double MoM[];
double MoMHup[];
double MoMHdn[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators setting
    SetIndexBuffer(0, MoM);
    SetIndexBuffer(1, MoMHup);
    SetIndexBuffer(2, MoMHdn);
//----
    SetIndexStyle(0, DRAW_LINE);
    SetIndexStyle(1, DRAW_NONE);
    SetIndexStyle(2, DRAW_NONE); 
//----        
    IndicatorShortName("Momentum T3(" + MoM_Period + ", " + T3_Period + ")");
    SetIndexLabel(0, "T3 Momentum");     
    SetIndexLabel(1, NULL);
    SetIndexLabel(2, NULL);   
//---- variable reset
    b2 = b*b;
    b3 = b2*b;
    c1 = -b3;
    c2 = (3*(b2 + b3));
    c3 = -3*(2*b2 + b + b3);
    c4 = (1 + 3*b + b3 + 3*b2);
    n = T3_Period;
//----
    if(n < 1) 
        n = 1;
   
    w1 = 2 / (n + 1);
    w2 = 1 - w1;    
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;  
//---- indicator calculation
   for(int i = Bars - 1; i >= 0; i--)
     {   
       MoM[i] = (Close[i]-Close[i+MoM_Period]);
       e1 = w1*MoM[i] + w2*e1;
       e2 = w1*e1 + w2*e2;
       e3 = w1*e2 + w2*e3;
       e4 = w1*e3 + w2*e4;
       e5 = w1*e4 + w2*e5;
       e6 = w1*e5 + w2*e6;    
       MoM[i] = c1*e6 + c2*e5 + c3*e4 + c4*e3;  
       //----
       if(MoM[i] >= 0)
           MoMHup[i] = MoM[i];
       else
           MoMHup[i] = 0;   
       //----
       if(MoM[i] < 0 )
           MoMHdn[i] = MoM[i];
       else
           MoMHdn[i] = 0; 
     } 
     if(Histogram == true)
      {
         for(i=0; i<limit; i++)
         {
               SetIndexStyle(1,DRAW_HISTOGRAM);
               SetIndexStyle(2,DRAW_HISTOGRAM);             
         } 
         }   
//----
   return(0);
  }
//+------------------------------------------------------------------+